#!/usr/bin/env python
import commands
import time
import sys
try:
	import pygtk
	pygtk.require("2.0")
except:
	pass
try:
	import gtk
	import gtk.glade
except:
	sys.exit(1)


history = []
history_pointer = 0
new_line = False
global_widgets={}

def init(wtree):
	## define global widgets here
	## expose events happen once when the window is first loaded
	## this is good for thing that you need to run at the start
	## of the program
	global global_widgets
	global_widgets["status"] = wtree.get_widget("statusbar1")
	pass




def set_status(msg):
	global global_widgets
	global_widgets["status"].pop(1)
	global_widgets["status"].push(1, msg)


def on_quit_activate(widget, data, wtree):
	gtk.main_quit()
	pass
	
def on_button_press(widget, data, wtree):
	global new_line, history, history_pointer
	wname = widget.get_name()
	register = wtree.get_widget("register")
	register_text = register.get_text()
	#new line if for clearing after the equals has been pressed
	# and the user did not press the clear button yet
	if new_line:
		register_text="" 
		new_line=False
	
	if wname == "backspace":
		register_text = register_text[:-1]
	elif wname == "clear":
		register_text = ""
	elif wname == "clear_meta":
		register_text = ""
	elif wname == "switch_sine":
		register_text = "-("+register_text+")"
	elif wname == "equals":
		try:
			exec("tmp="+register_text)
		except:
			set_status("ERROR: something wrong with input")
			tmp=0
		history.append(register_text)
		history.append(str(tmp))
		
		register_text = str(tmp)
		del tmp
		history_pointer+=1
		new_line = True
	elif wname == "multiply":
		register_text = register_text+"*"
	else:		
		register_text = register_text+widget.get_label()
	register.set_text(register_text)



def on_fowardinhistory_activate(widget, data, wtree):
	global history, history_pointer
	#print history_pointer, 	history
	register = wtree.get_widget("register")
	history_pointer+=1
	if history_pointer>=len(history):
		history_pointer=len(history)-1
		set_status("no more history!")
		return
	register.set_text(history[history_pointer])
	pass

def on_backinhistory_activate(widget, data, wtree):
	global history, history_pointer
	#print history
	register = wtree.get_widget("register")
	history_pointer-=1
	if len(history)==0 or history_pointer < 0:
		set_status("no more history!")
		history_pointer=0
		return
	register.set_text(history[history_pointer])
	pass



def on_about_dialog_activate(widget, data, wtree):
	about = wtree.get_widget("aboutdialog1")
	responce = about.run()
	if responce == 	gtk.RESPONSE_CANCEL or responce==gtk.RESPONSE_DELETE_EVENT:
		about.hide()
	pass

