################################
### Callback functions 		  ##
################################

package simpleTextEditorCallbacks;

use vars qw($gladexml);
my $text_area;
sub init{
	$gladexml = $_[0];
	$text_area = $gladexml->get_widget("text_area");
	print "initlize \n";
}

sub add_message{
	my $buffer, $iter;
	$buffer = $text_area->get_buffer();
	$iter = $buffer->get_start_iter();
	$buffer->insert($iter, $_[0]);
}
sub on_edit_redo_activate{
	add_message( "function 'on_edit_redo_activate' not implmented\n");
}
sub on_gtk_file_save_as_activate{
	add_message( "function 'on_gtk_file_save_as_activate' not implmented\n");
}
sub on_edit_undo_activate{
	add_message( "function 'on_edit_undo_activate' not implmented\n");
}
sub on_edit_paste_activate{
	add_message( "function 'on_edit_paste_activate' not implmented\n");
}
sub on_edit_cut_activate{
	add_message( "function 'on_edit_cut_activate' not implmented\n");
}
sub gtk_main_quit{
	Gtk2->main_quit;
}
sub on_file_save_activate{
	add_message( "function 'on_file_save_activate' not implmented\n");
}
sub on_view_line_numbers_toggled{
	add_message( "function 'on_view_line_numbers_toggled' not implmented\n");
}
sub on_help_about_activate{
	my $about,$responce;
	#glob $gladexml;
	$about = $gladexml->get_widget('main_about');
	print $about;
	print "\n";
	$responce = $about->run();
	if ($responce eq 'cancel')
	{
		$about->hide();
	}
	
	#print $responce;
}
sub on_file_open_activate{
	add_message( "function 'on_file_open_activate' not implmented\n");
}
sub on_file_new_activate{
	add_message( "function 'on_file_new_activate' not implmented\n");
}
sub on_edit_copy_activate{
	add_message( "function 'on_edit_copy_activate' not implmented\n");
}
sub on_edit_delete_activate{
	add_message( "function 'on_edit_delete_activate' not implmented\n");
}






1;
